#ifndef CONCATWORDSNETWORK__H
#define CONCATWORDSNETWORK__H

#include "NeuralNetwork.hpp"

class ConcatWordsNetworkImpl : public NeuralNetworkImpl
{
  private :

  torch::nn::Embedding wordEmbeddings{nullptr};
  torch::nn::Linear linear1{nullptr};
  torch::nn::Linear linear2{nullptr};

  std::vector<torch::Tensor> _denseParameters;
  std::vector<torch::Tensor> _sparseParameters;

  public :

  ConcatWordsNetworkImpl(int nbOutputs, int leftBorder, int rightBorder, int nbStackElements);
  torch::Tensor forward(torch::Tensor input) override;
  std::vector<torch::Tensor> & denseParameters() override;
  std::vector<torch::Tensor> & sparseParameters() override;
};

#endif
